package br.inf.mfp.gestaoadministrativa.app;

import br.inf.mfp.gestaoadministrativa.entity.Pedido;
import br.inf.mfp.gestaoadministrativa.entity.SituacaoPedido;
import io.jmix.core.DataManager;
import io.jmix.core.security.CurrentAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.UUID;

@Component("ga_PedidoBean")
public class PedidoBean {

    @Autowired
    private DataManager dataManager;
    @Autowired
    private CurrentAuthentication usuarioAut;

    public boolean AlterarPedido(Pedido vPedido, SituacaoPedido vSituacaoEsperada, SituacaoPedido situacaoNova) throws gaException {
        boolean retorno = false;

        if (vPedido != null){

            Pedido pedido = dataManager.load(Pedido.class)
                    .query("e.id = :id")
                    .parameter("id",vPedido.getId())
                    .one();

            if (!pedido.getSituacaoPedido().equals(vSituacaoEsperada))
            {
                throw new gaException( String.format("Pedido com situação atual(%s), diferente da esperada(%s)",pedido.getSituacaoPedido(),vSituacaoEsperada));
            }

            if (situacaoNova.equals(SituacaoPedido.CONFIRMADO)){
                if (pedido.getItemPedido().size() == 0){
                    throw new gaException( "Pedido não pode ser confirmado pois não há itens nele");
                }
            }
            pedido.setSituacaoPedido(situacaoNova);
            pedido.setLastModifiedBy(usuarioAut.getUser().getUsername());
            pedido.setLastModifiedDate(new Date());
            dataManager.save(pedido);
            retorno = true;
        }

        return retorno;
    }

    /*public boolean AlterarPedidoPagamento(Pedido vPedido, SituacaoPagamento vSituacaoEsperada, SituacaoPagamento situacaoNova) throws gaException {
        boolean retorno = false;

        if (vPedido != null){

            Pedido pedido = dataManager.load(Pedido.class)
                    .query("e.id = :id")
                    .parameter("id",vPedido.getId())
                    .one();

            *//*if (!pedido.getSituacaoPagamento().equals(vSituacaoEsperada))
            {
                throw new gaException( String.format("Pedido com situação atual(%s), diferente da esperada(%s)",pedido.getSituacaoPedido(),vSituacaoEsperada));
            }
            pedido.setSituacaoPagamento(situacaoNova);*//*
            pedido.setLastModifiedBy(usuarioAut.getUser().getUsername());
            pedido.setLastModifiedDate(new Date());
            dataManager.save(pedido);
            retorno = true;
        }

        return retorno;
    }*/

    public Pedido consultaPedido(Integer numero, UUID grupoId) throws gaException {

        Pedido linha;

        try{

            linha = dataManager.load(Pedido.class)
                    .query("e.numero = :numero AND e.grupoEconomico.id = :idGrupo")
                    .parameter("numero",numero)
                    .parameter("idGrupo",grupoId)
                    .one();

        }
        catch (Exception ee){
            throw new gaException("Registro não localizado");
        }

        return linha;

    }
}