package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTRATO_TITULO", indexes = {
        @Index(name = "IDX_CONTRATO_TITULO_CONTRATO", columnList = "CONTRATO_ID"),
        @Index(name = "IDX_CONTRATO_TITULO_TITULO_PAGAR", columnList = "TITULO_PAGAR_ID"),
        @Index(name = "IDX_CONTRATO_TITULO_TITULO_RECEBER", columnList = "TITULO_RECEBER_ID")
})
@Entity(name = "ga_ContratoTitulo")
public class ContratoTitulo {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @JoinColumn(name = "CONTRATO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Contrato contrato;

    @JoinColumn(name = "TITULO_PAGAR_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private TituloPagar tituloPagar;

    @JoinColumn(name = "TITULO_RECEBER_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private TituloReceber tituloReceber;

    public TituloReceber getTituloReceber() {
        return tituloReceber;
    }

    public void setTituloReceber(TituloReceber tituloReceber) {
        this.tituloReceber = tituloReceber;
    }

    public TituloPagar getTituloPagar() {
        return tituloPagar;
    }

    public void setTituloPagar(TituloPagar tituloPagar) {
        this.tituloPagar = tituloPagar;
    }

    public Contrato getContrato() {
        return contrato;
    }

    public void setContrato(Contrato contrato) {
        this.contrato = contrato;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}