package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "INTEGRADOR", indexes = {
        @Index(name = "IDX_GA_INTEGRADOR_CONTRATO", columnList = "CONTRATO_ID"),
        @Index(name = "IDX_INTEGRADOR_PESSOA", columnList = "PESSOA_ID"),
        @Index(name = "IDX_INTEGRADOR_GRUPO_ECONOMICO", columnList = "GRUPO_ECONOMICO_ID"),
        @Index(name = "IDX_INTEGRADOR_EMPRESA", columnList = "EMPRESA_ID")
})
@Entity(name = "ga_Integrador")
public class Integrador {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @JoinColumn(name = "GRUPO_ECONOMICO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private GrupoEconomico grupoEconomico;

    @JoinColumn(name = "EMPRESA_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresa;

    @JoinColumn(name = "CONTRATO_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Contrato contrato;

    @Column(name = "TIPO_INTEGRADOR", nullable = false)
    @NotNull
    private Integer tipoIntegrador;

    @NotNull
    @Column(name = "SITUACAO", nullable = false)
    private Integer situacao = SituacaoIntegrador.PENDENTE.getId();

    @Column(name = "CNPJ", nullable = false, length = 18)
    @NotNull
    private String cnpj;

    @JoinColumn(name = "PESSOA_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Pessoa pessoa;

    @Column(name = "CHAVE_IDENTIFICACAO", nullable = false, length = 100)
    @NotNull
    private String chaveIdentificacao;

    @Column(name = "DESCRICAO", length = 100)
    private String descricao;

    @Column(name = "NOME_PC", length = 100)
    private String nomePc;

    @Column(name = "IP_PC", length = 100)
    private String ipPc;

    @Column(name = "DH_ULTIMA_COMUNICACAO")
    @Temporal(TemporalType.TIMESTAMP)
    private Date dhUltimaComunicacao;

    @Column(name = "VERSAO_ATUAL", length = 40)
    private String versaoAtual;

    public String getVersaoAtual() {
        return versaoAtual;
    }

    public void setVersaoAtual(String versaoAtual) {
        this.versaoAtual = versaoAtual;
    }

    public Date getDhUltimaComunicacao() {
        return dhUltimaComunicacao;
    }

    public void setDhUltimaComunicacao(Date dhUltimaComunicacao) {
        this.dhUltimaComunicacao = dhUltimaComunicacao;
    }

    public String getIpPc() {
        return ipPc;
    }

    public void setIpPc(String ipPc) {
        this.ipPc = ipPc;
    }

    public String getNomePc() {
        return nomePc;
    }

    public void setNomePc(String nomePc) {
        this.nomePc = nomePc;
    }

    public String getDescricao() {
        return descricao;
    }

    public void setDescricao(String descricao) {
        this.descricao = descricao;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public GrupoEconomico getGrupoEconomico() {
        return grupoEconomico;
    }

    public void setGrupoEconomico(GrupoEconomico grupoEconomico) {
        this.grupoEconomico = grupoEconomico;
    }

    public String getChaveIdentificacao() {
        return chaveIdentificacao;
    }

    public void setChaveIdentificacao(String chaveIdentificacao) {
        this.chaveIdentificacao = chaveIdentificacao;
    }

    public Pessoa getPessoa() {
        return pessoa;
    }

    public void setPessoa(Pessoa pessoa) {
        this.pessoa = pessoa;
    }

    public String getCnpj() {
        return cnpj;
    }

    public void setCnpj(String cnpj) {
        this.cnpj = cnpj;
    }

    public SituacaoIntegrador getSituacao() {
        return situacao == null ? null : SituacaoIntegrador.fromId(situacao);
    }

    public void setSituacao(SituacaoIntegrador situacao) {
        this.situacao = situacao == null ? null : situacao.getId();
    }

    public TipoIntegrador getTipoIntegrador() {
        return tipoIntegrador == null ? null : TipoIntegrador.fromId(tipoIntegrador);
    }

    public void setTipoIntegrador(TipoIntegrador tipoIntegrador) {
        this.tipoIntegrador = tipoIntegrador == null ? null : tipoIntegrador.getId();
    }

    public Contrato getContrato() {
        return contrato;
    }

    public void setContrato(Contrato contrato) {
        this.contrato = contrato;
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}