package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "ITEM", indexes = {
        @Index(name = "IDX_GA_ITEM_CATEGORIA", columnList = "CATEGORIA_ID"),
        @Index(name = "IDX_ITEM_GRUPO_ECONOMICO", columnList = "GRUPO_ECONOMICO_ID"),
        @Index(name = "IDX_GA_ITEM_UNQ", columnList = "CODIGO, GRUPO_ECONOMICO_ID", unique = true),
        @Index(name = "IDX_GA_ITEM_UNQ_1", columnList = "GRUPO_ECONOMICO_ID, CODIGO_BARRA", unique = true)
})
@Entity(name = "ga_Item")
public class Item {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @JoinColumn(name = "GRUPO_ECONOMICO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private GrupoEconomico grupoEconomico;

    @JmixGeneratedValue
    @NumberFormat(pattern = "###,##0")
    @Column(name = "CODIGO", nullable = false)
    @NotNull
    private Integer codigo;

    @Column(name = "DESCRICAO", nullable = false, length = 100)
    @NotNull
    private String descricao;

    @NotNull
    @Column(name = "SITUACAO", nullable = false)
    private Integer situacao = Situacao.ATIVO.getId();

    @JoinColumn(name = "CATEGORIA_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Categoria categoria;

    @Column(name = "CODIGO_BARRA", length = 30)
    private String codigoBarra;

    @NumberFormat(pattern = "###,##0.000", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "VALOR_CUSTO", precision = 19, scale = 2)
    private BigDecimal valorCusto;

    @NumberFormat(pattern = "###,##0.00", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "VALOR_VENDA", precision = 19, scale = 2)
    private BigDecimal valorVenda;

    public GrupoEconomico getGrupoEconomico() {
        return grupoEconomico;
    }

    public void setGrupoEconomico(GrupoEconomico grupoEconomico) {
        this.grupoEconomico = grupoEconomico;
    }

    public BigDecimal getValorVenda() {
        return valorVenda;
    }

    public void setValorVenda(BigDecimal valorVenda) {
        this.valorVenda = valorVenda;
    }

    public BigDecimal getValorCusto() {
        return valorCusto;
    }

    public void setValorCusto(BigDecimal valorCusto) {
        this.valorCusto = valorCusto;
    }

    public String getCodigoBarra() {
        return codigoBarra;
    }

    public void setCodigoBarra(String codigoBarra) {
        this.codigoBarra = codigoBarra;
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    public Situacao getSituacao() {
        return situacao == null ? null : Situacao.fromId(situacao);
    }

    public void setSituacao(Situacao situacao) {
        this.situacao = situacao == null ? null : situacao.getId();
    }

    public String getDescricao() {
        return descricao;
    }

    public void setDescricao(String descricao) {
        this.descricao = descricao;
    }

    public Integer getCodigo() {
        return codigo;
    }

    public void setCodigo(Integer codigo) {
        this.codigo = codigo;
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @InstanceName
    @DependsOnProperties({"codigo", "descricao"})
    public String getInstanceName() {
        return String.format("%s - %s", codigo.toString(), descricao);
    }
}