package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.UUID;

@JmixEntity
@Table(name = "ITEM_PEDIDO", indexes = {
        @Index(name = "IDX_GA_ITEM_PEDIDO_PEDIDO", columnList = "PEDIDO_ID"),
        @Index(name = "IDX_GA_ITEM_PEDIDO_ITEM", columnList = "ITEM_ID"),
        @Index(name = "IDX_GA_ITEM_PEDIDO_UNQ", columnList = "PEDIDO_ID, ITEM_ID", unique = true)
})
@Entity(name = "ga_ItemPedido")
public class ItemPedido {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @JoinColumn(name = "PEDIDO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Pedido pedido;

    @JoinColumn(name = "ITEM_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Item item;

    @Column(name = "CANCELADO", nullable = false)
    @NotNull
    private Boolean cancelado = false;

    @NotNull
    @NumberFormat(pattern = "###,##0.000")
    @Column(name = "QUANTIDADE", nullable = false)
    private Double quantidade;

    @NumberFormat(pattern = "###,##0.000")
    @Column(name = "VALOR_UNITARIO", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorUnitario;

    @NumberFormat(pattern = "###,##0.00")
    @Column(name = "VALOR_TOTAL", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorTotal;

    public void setQuantidade(Double quantidade) {
        this.quantidade = quantidade;
    }

    public Double getQuantidade() {
        return quantidade;
    }

    public Boolean getCancelado() {
        return cancelado;
    }

    public void setCancelado(Boolean cancelado) {
        this.cancelado = cancelado;
    }

    public BigDecimal getValorTotal() {
        return valorTotal;
    }

    public void setValorTotal(BigDecimal valorTotal) {
        this.valorTotal = valorTotal;
    }

    public BigDecimal getValorUnitario() {
        return valorUnitario;
    }

    public void setValorUnitario(BigDecimal valorUnitario) {
        this.valorUnitario = valorUnitario;
    }

    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        this.item = item;
    }

    public Pedido getPedido() {
        return pedido;
    }

    public void setPedido(Pedido pedido) {
        this.pedido = pedido;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}