package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "MOVIMENTO_ESTOQUE", indexes = {
        @Index(name = "IDX_GA_MOVIMENTO_ESTOQUE_ITEM", columnList = "ITEM_ID"),
        @Index(name = "IDX_GA_MOVIMENTO_ESTOQUE_TIPO_MOVIMENTO", columnList = "TIPO_MOVIMENTO_ID"),
        @Index(name = "IDX_GA_MOVIMENTO_ESTOQUE_EMPRESA", columnList = "EMPRESA_ID")
})
@Entity(name = "ga_MovimentoEstoque")
public class MovimentoEstoque {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @JoinColumn(name = "EMPRESA_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresa;

    @JoinColumn(name = "ITEM_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Item item;

    @Column(name = "DATA_MOVIMENTO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataMovimento;

    @JoinColumn(name = "TIPO_MOVIMENTO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private TipoMovimento tipoMovimento;

    @Column(name = "ID_ORIGEM", nullable = false)
    @NotNull
    private UUID idOrigem;

    @Column(name = "ORIGEM", nullable = false)
    @NotNull
    private Integer origem;

    @NumberFormat(pattern = "###,##0.000", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "QUANTIDADE", nullable = false)
    @NotNull
    private Double quantidade;

    @NumberFormat(pattern = "###,##0.000")
    @Column(name = "VALOR_CUSTO", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorCusto;

    @NumberFormat(pattern = "###,##0.000")
    @Column(name = "VALOR_MOVIMENTO", precision = 19, scale = 2)
    private BigDecimal valorMovimento;

    public BigDecimal getValorMovimento() {
        return valorMovimento;
    }

    public void setValorMovimento(BigDecimal valorMovimento) {
        this.valorMovimento = valorMovimento;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public BigDecimal getValorCusto() {
        return valorCusto;
    }

    public void setValorCusto(BigDecimal valorCusto) {
        this.valorCusto = valorCusto;
    }

    public Double getQuantidade() {
        return quantidade;
    }

    public void setQuantidade(Double quantidade) {
        this.quantidade = quantidade;
    }

    public OrigemMovEst getOrigem() {
        return origem == null ? null : OrigemMovEst.fromId(origem);
    }

    public void setOrigem(OrigemMovEst origem) {
        this.origem = origem == null ? null : origem.getId();
    }

    public UUID getIdOrigem() {
        return idOrigem;
    }

    public void setIdOrigem(UUID idOrigem) {
        this.idOrigem = idOrigem;
    }

    public TipoMovimento getTipoMovimento() {
        return tipoMovimento;
    }

    public void setTipoMovimento(TipoMovimento tipoMovimento) {
        this.tipoMovimento = tipoMovimento;
    }

    public Date getDataMovimento() {
        return dataMovimento;
    }

    public void setDataMovimento(Date dataMovimento) {
        this.dataMovimento = dataMovimento;
    }

    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        this.item = item;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}