package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "OPERACAO_ESTOQUE", indexes = {
        @Index(name = "IDX_GA_OPERACAO_ESTOQUE_EMPRESA_ORIGEM", columnList = "EMPRESA_ORIGEM_ID"),
        @Index(name = "IDX_GA_OPERACAO_ESTOQUE_EMPRESA_DESTINO", columnList = "EMPRESA_DESTINO_ID"),
        @Index(name = "IDX_GA_OPERACAO_ESTOQUE_OPERACAO_DESTINO", columnList = "OPERACAO_DESTINO_ID")
})
@Entity(name = "ga_OperacaoEstoque")
public class OperacaoEstoque {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @Column(name = "TIPO_OPERACAO", nullable = false)
    @NotNull
    private Integer tipoOperacao = TipoOperacao.BAIXA_CONSUMO.getId();

    @Column(name = "SITUACAO_OPERACAO", nullable = false)
    @NotNull
    private Integer situacaoOperacao = SituacaoOperacao.PENDENTE.getId();

    @JoinColumn(name = "EMPRESA_ORIGEM_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresaOrigem;

    @JoinColumn(name = "EMPRESA_DESTINO_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Empresa empresaDestino;

    @Column(name = "DATA_MOVIMENTO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataMovimento = new Date();

    @Column(name = "OBSERVACAO")
    private String observacao;

    @JoinColumn(name = "OPERACAO_DESTINO_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private OperacaoEstoque operacaoDestino;

    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "operacaoEstoque")
    private List<OperacaoItem> operacaoItem;

    public List<OperacaoItem> getOperacaoItem() {
        return operacaoItem;
    }

    public void setOperacaoItem(List<OperacaoItem> operacaoItem) {
        this.operacaoItem = operacaoItem;
    }

    public OperacaoEstoque getOperacaoDestino() {
        return operacaoDestino;
    }

    public void setOperacaoDestino(OperacaoEstoque operacaoDestino) {
        this.operacaoDestino = operacaoDestino;
    }

    public SituacaoOperacao getSituacaoOperacao() {
        return situacaoOperacao == null ? null : SituacaoOperacao.fromId(situacaoOperacao);
    }

    public void setSituacaoOperacao(SituacaoOperacao situacaoOperacao) {
        this.situacaoOperacao = situacaoOperacao == null ? null : situacaoOperacao.getId();
    }

    public String getObservacao() {
        return observacao;
    }

    public void setObservacao(String observacao) {
        this.observacao = observacao;
    }

    public Date getDataMovimento() {
        return dataMovimento;
    }

    public void setDataMovimento(Date dataMovimento) {
        this.dataMovimento = dataMovimento;
    }

    public Empresa getEmpresaDestino() {
        return empresaDestino;
    }

    public void setEmpresaDestino(Empresa empresaDestino) {
        this.empresaDestino = empresaDestino;
    }

    public Empresa getEmpresaOrigem() {
        return empresaOrigem;
    }

    public void setEmpresaOrigem(Empresa empresaOrigem) {
        this.empresaOrigem = empresaOrigem;
    }

    public TipoOperacao getTipoOperacao() {
        return tipoOperacao == null ? null : TipoOperacao.fromId(tipoOperacao);
    }

    public void setTipoOperacao(TipoOperacao tipoOperacao) {
        this.tipoOperacao = tipoOperacao == null ? null : tipoOperacao.getId();
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @InstanceName
    @DependsOnProperties({"tipoOperacao", "dataMovimento", "empresaOrigem"})
    public String getInstanceName() {
        return String.format("%s %s %s", tipoOperacao, dataMovimento, empresaOrigem);
    }
}