package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.UUID;

@JmixEntity
@Table(name = "OPERACAO_ITEM", indexes = {
        @Index(name = "IDX_GA_OPERACAO_ITEM_OPERACAO_ESTOQUE", columnList = "OPERACAO_ESTOQUE_ID"),
        @Index(name = "IDX_GA_OPERACAO_ITEM_ITEM", columnList = "ITEM_ID"),
        @Index(name = "IDX_GA_OPERACAO_ITEM_MOVIMENTO_ESTOQUE", columnList = "MOVIMENTO_ESTOQUE_ID")
})
@Entity(name = "ga_OperacaoItem")
public class OperacaoItem {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @JoinColumn(name = "OPERACAO_ESTOQUE_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private OperacaoEstoque operacaoEstoque;

    @JoinColumn(name = "ITEM_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Item item;

    @NumberFormat(pattern = "###,##0.00")
    @Column(name = "QUANTIDADE", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal quantidade;

    @JoinColumn(name = "MOVIMENTO_ESTOQUE_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private MovimentoEstoque movimentoEstoque;

    public MovimentoEstoque getMovimentoEstoque() {
        return movimentoEstoque;
    }

    public void setMovimentoEstoque(MovimentoEstoque movimentoEstoque) {
        this.movimentoEstoque = movimentoEstoque;
    }

    public BigDecimal getQuantidade() {
        return quantidade;
    }

    public void setQuantidade(BigDecimal quantidade) {
        this.quantidade = quantidade;
    }

    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        this.item = item;
    }

    public OperacaoEstoque getOperacaoEstoque() {
        return operacaoEstoque;
    }

    public void setOperacaoEstoque(OperacaoEstoque operacaoEstoque) {
        this.operacaoEstoque = operacaoEstoque;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @InstanceName
    @DependsOnProperties({"item", "quantidade"})
    public String getInstanceName() {
        return String.format("%s %s", item, quantidade);
    }
}