package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "PARCELA_PEDIDO", indexes = {
        @Index(name = "IDX_PARCELA_PEDIDO_PEDIDO", columnList = "PEDIDO_ID"),
        @Index(name = "IDX_PARCELA_PEDIDO_TITULO_PAGAR", columnList = "TITULO_PAGAR_ID")
})
@Entity(name = "ga_ParcelaPedido")
public class ParcelaPedido {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @NotNull
    @JoinColumn(name = "PEDIDO_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Pedido pedido;

    @NumberFormat(pattern = "###,##0")
    @Column(name = "NUMERO", nullable = false)
    @NotNull
    private Integer numero;

    @NumberFormat(pattern = "###,##0.00")
    @Column(name = "VALOR", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valor;

    @Column(name = "DATA_VENCIMENTO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataVencimento;

    @Column(name = "REGISTRO_GERAR", nullable = false)
    @NotNull
    private Integer registroGerar = RegistroGerar.PENDENTE.getId();

    @JoinColumn(name = "TITULO_PAGAR_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private TituloPagar tituloPagar;

    public void setPedido(Pedido pedido) {
        this.pedido = pedido;
    }

    public Pedido getPedido() {
        return pedido;
    }

    public RegistroGerar getRegistroGerar() {
        return registroGerar == null ? null : RegistroGerar.fromId(registroGerar);
    }

    public void setRegistroGerar(RegistroGerar registroGerar) {
        this.registroGerar = registroGerar == null ? null : registroGerar.getId();
    }

    public TituloPagar getTituloPagar() {
        return tituloPagar;
    }

    public void setTituloPagar(TituloPagar tituloPagar) {
        this.tituloPagar = tituloPagar;
    }

    public Date getDataVencimento() {
        return dataVencimento;
    }

    public void setDataVencimento(Date dataVencimento) {
        this.dataVencimento = dataVencimento;
    }

    public BigDecimal getValor() {
        return valor;
    }

    public void setValor(BigDecimal valor) {
        this.valor = valor;
    }

    public Integer getNumero() {
        return numero;
    }

    public void setNumero(Integer numero) {
        this.numero = numero;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}