package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "TITULO_PAGAR", indexes = {
        @Index(name = "IDX_GA_TITULO_PAGAR_FORNECEDOR", columnList = "FORNECEDOR_ID"),
        @Index(name = "IDX_TITULO_PAGAR_EMPRESA", columnList = "EMPRESA_ID")
})
@Entity(name = "ga_TituloPagar")
public class TituloPagar {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @JoinColumn(name = "EMPRESA_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresa;

    @JoinColumn(name = "FORNECEDOR_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Pessoa fornecedor;

    @Column(name = "NUMERO_DOCUMENTO", nullable = false, length = 20)
    @NotNull
    private String numeroDocumento;

    @Column(name = "DATA_EMISSAO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataEmissao;

    @Column(name = "DATA_VENCIMENTO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataVencimento;

    @Column(name = "SITUACAO_TITULO", nullable = false)
    @NotNull
    private Integer situacaoTitulo = SituacaoTitulo.ABERTO.getId();

    @NumberFormat(pattern = "###,##0.00", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "VALOR_ORIGINAL", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorOriginal = BigDecimal.ZERO;

    @NumberFormat(pattern = "###,##0.00", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "VALOR_ATUALIZADO", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorAtualizado = BigDecimal.ZERO;

    @NumberFormat(pattern = "###,##0.00", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "VALOR_JUROS", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorJuros = BigDecimal.ZERO;

    @NumberFormat(pattern = "###,##0.00", decimalSeparator = ",", groupingSeparator = ".")
    @Column(name = "VALOR_MULTA", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorMulta = BigDecimal.ZERO;

    @Column(name = "ORIGEM_TITULO", nullable = false)
    @NotNull
    private Integer origemTitulo;

    @Column(name = "OBSERVACAO")
    private String observacao;

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public String getObservacao() {
        return observacao;
    }

    public void setObservacao(String observacao) {
        this.observacao = observacao;
    }

    public OrigemTitulo getOrigemTitulo() {
        return origemTitulo == null ? null : OrigemTitulo.fromId(origemTitulo);
    }

    public void setOrigemTitulo(OrigemTitulo origemTitulo) {
        this.origemTitulo = origemTitulo == null ? null : origemTitulo.getId();
    }

    public String getNumeroDocumento() {
        return numeroDocumento;
    }

    public void setNumeroDocumento(String numeroDocumento) {
        this.numeroDocumento = numeroDocumento;
    }

    public BigDecimal getValorMulta() {
        return valorMulta;
    }

    public void setValorMulta(BigDecimal valorMulta) {
        this.valorMulta = valorMulta;
    }

    public BigDecimal getValorJuros() {
        return valorJuros;
    }

    public void setValorJuros(BigDecimal valorJuros) {
        this.valorJuros = valorJuros;
    }

    public BigDecimal getValorAtualizado() {
        return valorAtualizado;
    }

    public void setValorAtualizado(BigDecimal valorAtualizado) {
        this.valorAtualizado = valorAtualizado;
    }

    public BigDecimal getValorOriginal() {
        return valorOriginal;
    }

    public void setValorOriginal(BigDecimal valorOriginal) {
        this.valorOriginal = valorOriginal;
    }

    public SituacaoTitulo getSituacaoTitulo() {
        return situacaoTitulo == null ? null : SituacaoTitulo.fromId(situacaoTitulo);
    }

    public void setSituacaoTitulo(SituacaoTitulo situacaoTitulo) {
        this.situacaoTitulo = situacaoTitulo == null ? null : situacaoTitulo.getId();
    }

    public Date getDataVencimento() {
        return dataVencimento;
    }

    public void setDataVencimento(Date dataVencimento) {
        this.dataVencimento = dataVencimento;
    }

    public Date getDataEmissao() {
        return dataEmissao;
    }

    public void setDataEmissao(Date dataEmissao) {
        this.dataEmissao = dataEmissao;
    }

    public Pessoa getFornecedor() {
        return fornecedor;
    }

    public void setFornecedor(Pessoa fornecedor) {
        this.fornecedor = fornecedor;
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @InstanceName
    @DependsOnProperties({"fornecedor", "numeroDocumento", "dataEmissao", "valorOriginal"})
    public String getInstanceName() {
        return String.format("%s - %s - %s - %s", fornecedor, numeroDocumento, dataEmissao, valorOriginal);
    }
}