package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "TITULO_RECEBER", indexes = {
        @Index(name = "IDX_GA_TITULO_RECEBER_EMPRESA", columnList = "EMPRESA_ID"),
        @Index(name = "IDX_GA_TITULO_RECEBER_CLIENTE", columnList = "CLIENTE_ID")
})
@Entity(name = "ga_TituloReceber")
public class TituloReceber {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @JoinColumn(name = "EMPRESA_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresa;

    @JoinColumn(name = "CLIENTE_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Pessoa cliente;

    @Column(name = "SITUACAO_TITULO", nullable = false)
    @NotNull
    private Integer situacaoTitulo;

    @NumberFormat(pattern = "###,##0")
    @Column(name = "NUMERO")
    private Integer numero;

    @Column(name = "DATA_EMISSAO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataEmissao;

    @Column(name = "DATA_VENCIMENTO", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date dataVencimento;

    @NumberFormat(pattern = "###,##0.00")
    @Column(name = "VALOR_ORIGINAL", nullable = false, precision = 19, scale = 2)
    @NotNull
    private BigDecimal valorOriginal;

    @Column(name = "ORIGEM_TITULO", nullable = false)
    @NotNull
    private Integer origemTitulo;

    @Column(name = "OBSERVACAO")
    private String observacao;

    @NumberFormat(pattern = "###,##0.00")
    @NotNull
    @Column(name = "VALOR_DESCONTO", nullable = false, precision = 19, scale = 2)
    private BigDecimal valorDesconto;

    @NumberFormat(pattern = "###,##0.00")
    @NotNull
    @Column(name = "VALOR_MULTA", nullable = false, precision = 19, scale = 2)
    private BigDecimal valorMulta;

    @NumberFormat(pattern = "###,##0.00")
    @NotNull
    @Column(name = "VALOR_JUROS", nullable = false, precision = 19, scale = 2)
    private BigDecimal valorJuros;

    public Integer getNumero() {
        return numero;
    }

    public void setNumero(Integer numero) {
        this.numero = numero;
    }

    public Pessoa getCliente() {
        return cliente;
    }

    public void setCliente(Pessoa cliente) {
        this.cliente = cliente;
    }

    public BigDecimal getValorJuros() {
        return valorJuros;
    }

    public void setValorJuros(BigDecimal valorJuros) {
        this.valorJuros = valorJuros;
    }

    public BigDecimal getValorMulta() {
        return valorMulta;
    }

    public void setValorMulta(BigDecimal valorMulta) {
        this.valorMulta = valorMulta;
    }

    public BigDecimal getValorDesconto() {
        return valorDesconto;
    }

    public void setValorDesconto(BigDecimal valorDesconto) {
        this.valorDesconto = valorDesconto;
    }

    public String getObservacao() {
        return observacao;
    }

    public void setObservacao(String observacao) {
        this.observacao = observacao;
    }

    public OrigemTitulo getOrigemTitulo() {
        return origemTitulo == null ? null : OrigemTitulo.fromId(origemTitulo);
    }

    public void setOrigemTitulo(OrigemTitulo origemTitulo) {
        this.origemTitulo = origemTitulo == null ? null : origemTitulo.getId();
    }

    public SituacaoTitulo getSituacaoTitulo() {
        return situacaoTitulo == null ? null : SituacaoTitulo.fromId(situacaoTitulo);
    }

    public void setSituacaoTitulo(SituacaoTitulo situacaoTitulo) {
        this.situacaoTitulo = situacaoTitulo == null ? null : situacaoTitulo.getId();
    }

    public BigDecimal getValorOriginal() {
        return valorOriginal;
    }

    public void setValorOriginal(BigDecimal valorOriginal) {
        this.valorOriginal = valorOriginal;
    }

    public Date getDataVencimento() {
        return dataVencimento;
    }

    public void setDataVencimento(Date dataVencimento) {
        this.dataVencimento = dataVencimento;
    }

    public Date getDataEmissao() {
        return dataEmissao;
    }

    public void setDataEmissao(Date dataEmissao) {
        this.dataEmissao = dataEmissao;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @InstanceName
    @DependsOnProperties({"dataEmissao", "origemTitulo", "situacaoTitulo", "valorOriginal"})
    public String getInstanceName() {
        return String.format("%s - %s - %s - %s", dataEmissao.toString(), OrigemTitulo.fromId(origemTitulo), SituacaoTitulo.fromId(situacaoTitulo), valorOriginal);
    }
}