package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.FileRef;
import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.JmixEntity;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "GA_TRADUCAO")
@Entity(name = "ga_Traducao")
public class Traducao {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @Column(name = "PASTA_ORIGEM", nullable = false)
    @NotNull
    private String pastaOrigem;

    @Column(name = "TIPO_ORIGEM", nullable = false)
    @NotNull
    private String tipoOrigem = Linguagem.INGLES.getId();

    @Column(name = "TIPO_DESTINO", nullable = false)
    @NotNull
    private String tipoDestino = Linguagem.PORTUGUES_BR.getId();

    @OrderBy("ordem")
    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "traducao")
    private List<TraducaoLinhas> traducaoLinhas;

    @Column(name = "ARQUIVO_ORIGINAL", nullable = false)
    @Lob
    @NotNull
    private FileRef arquivoOriginal;

    @Column(name = "CABECALHO")
    @Lob
    private String cabecalho;

    public String getCabecalho() {
        return cabecalho;
    }

    public void setCabecalho(String cabecalho) {
        this.cabecalho = cabecalho;
    }

    public FileRef getArquivoOriginal() {
        return arquivoOriginal;
    }

    public void setArquivoOriginal(FileRef arquivoOriginal) {
        this.arquivoOriginal = arquivoOriginal;
    }

    public List<TraducaoLinhas> getTraducaoLinhas() {
        return traducaoLinhas;
    }

    public void setTraducaoLinhas(List<TraducaoLinhas> traducaoLinhas) {
        this.traducaoLinhas = traducaoLinhas;
    }

    public Linguagem getTipoDestino() {
        return tipoDestino == null ? null : Linguagem.fromId(tipoDestino);
    }

    public void setTipoDestino(Linguagem tipoDestino) {
        this.tipoDestino = tipoDestino == null ? null : tipoDestino.getId();
    }

    public Linguagem getTipoOrigem() {
        return tipoOrigem == null ? null : Linguagem.fromId(tipoOrigem);
    }

    public void setTipoOrigem(Linguagem tipoOrigem) {
        this.tipoOrigem = tipoOrigem == null ? null : tipoOrigem.getId();
    }

    public String getPastaOrigem() {
        return pastaOrigem;
    }

    public void setPastaOrigem(String pastaOrigem) {
        this.pastaOrigem = pastaOrigem;
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}