package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "USUARIO_EMPRESA", indexes = {
        @Index(name = "IDX_GA_USUARIO_EMPRESA_USUARIO", columnList = "USUARIO_ID"),
        @Index(name = "IDX_GA_USUARIO_EMPRESA_EMPRESA", columnList = "EMPRESA_ID"),
        @Index(name = "IDX_GA_USUARIO_EMPRESA_UNQ", columnList = "USUARIO_ID, EMPRESA_ID", unique = true)
})
@Entity(name = "ga_UsuarioEmpresa")
public class UsuarioEmpresa {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @JoinColumn(name = "USUARIO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private User usuario;

    @JoinColumn(name = "EMPRESA_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresa;

    @Column(name = "SITUACAO")
    private Integer situacao = Situacao.ATIVO.getId();

    public Situacao getSituacao() {
        return situacao == null ? null : Situacao.fromId(situacao);
    }

    public void setSituacao(Situacao situacao) {
        this.situacao = situacao == null ? null : situacao.getId();
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public User getUsuario() {
        return usuario;
    }

    public void setUsuario(User usuario) {
        this.usuario = usuario;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}