package br.inf.mfp.gestaoadministrativa.entity;

import io.jmix.core.FileRef;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "VERSAO_INTEGRADOR", indexes = {
        @Index(name = "IDX_GA_VERSAO_INTEGRADOR_UNQ", columnList = "TIPO_INTEGRADOR", unique = true)
})
@Entity(name = "ga_VersaoIntegrador")
public class VersaoIntegrador {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "TIPO_INTEGRADOR", nullable = false)
    @NotNull
    private Integer tipoIntegrador;

    @Column(name = "VERSAO", nullable = false, length = 50)
    @NotNull
    private String versao;

    @Column(name = "CHAVE_VALIDACAO", nullable = false)
    @NotNull
    private String chaveValidacao;

    @Column(name = "ARQUIVO")
    @Lob
    private FileRef arquivo;

    public String getChaveValidacao() {
        return chaveValidacao;
    }

    public void setChaveValidacao(String chaveValidacao) {
        this.chaveValidacao = chaveValidacao;
    }

    public FileRef getArquivo() {
        return arquivo;
    }

    public void setArquivo(FileRef arquivo) {
        this.arquivo = arquivo;
    }

    public String getVersao() {
        return versao;
    }

    public void setVersao(String versao) {
        this.versao = versao;
    }

    public TipoIntegrador getTipoIntegrador() {
        return tipoIntegrador == null ? null : TipoIntegrador.fromId(tipoIntegrador);
    }

    public void setTipoIntegrador(TipoIntegrador tipoIntegrador) {
        this.tipoIntegrador = tipoIntegrador == null ? null : tipoIntegrador.getId();
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @InstanceName
    @DependsOnProperties({"tipoIntegrador", "versao"})
    public String getInstanceName() {
        return String.format("%s %s", tipoIntegrador, versao);
    }
}