package br.inf.mfp.gestaoadministrativa.screen.cadastros.categoria;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.entity.Categoria;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.ButtonsPanel;
import io.jmix.ui.component.Filter;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Categoria.browse")
@UiDescriptor("categoria-browse.xml")
@LookupComponent("categoriasTable")
public class CategoriaBrowse extends StandardLookup<Categoria> {
    @Autowired
    private Notifications notifications;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;

    private GrupoEconomico filtroGe;
    @Autowired
    private ButtonsPanel buttonsPanel;
    @Autowired
    private Filter filter;

    @Subscribe(id = "categoriasDl", target = Target.DATA_LOADER)
    public void onCategoriasDlPreLoad(CollectionLoader.PreLoadEvent<Categoria> event) {
        if (filtroGe == null) {
            try {
                filtroGe = grupoEconomicoBean.retornarGE();
            } catch (Exception ee) {
                filtroGe = null;
            }
            if (filtroGe == null) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Usuário sem Grupo Econômico").show();
                event.preventLoad();
                buttonsPanel.setEnabled(false);
                filter.setEnabled(false);
            }
        }
    }


}