package br.inf.mfp.gestaoadministrativa.screen.cadastros.categoria;

import br.inf.mfp.gestaoadministrativa.app.GeradorBean;
import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.app.gaException;
import br.inf.mfp.gestaoadministrativa.entity.Categoria;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.core.EntityStates;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.EntityComboBox;
import io.jmix.ui.component.TextField;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Categoria.edit")
@UiDescriptor("categoria-edit.xml")
@EditedEntityContainer("categoriaDc")
public class CategoriaEdit extends StandardEditor<Categoria> {
    @Autowired
    private EntityStates entityStates;
    @Autowired
    private EntityComboBox<GrupoEconomico> grupoEconomicoField;
    @Autowired
    private Notifications notifications;
    @Autowired
    private GeradorBean geradorBean;
    @Autowired
    private TextField<Integer> codigoField;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {

        if ( entityStates.isNew(getEditedEntity()) ){
            try {

                codigoField.setValue(geradorBean.RetornoSeq("categoria_seq"));

                grupoEconomicoField.setValue( grupoEconomicoBean.retornarGE());

            } catch (gaException e) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Erro ao Carregar Grupo Economico").withDescription(e.getMessage()).show();
            }

        }

    }

    @Subscribe
    public void onBeforeCommitChanges(BeforeCommitChangesEvent event) {
        if (getEditedEntity().getGrupoEconomico() == null) {
            notifications.create(Notifications.NotificationType.ERROR).withCaption("Não Autorizado").show();
            event.preventCommit();
        }
    }




}