package br.inf.mfp.gestaoadministrativa.screen.cadastros.item;

import br.inf.mfp.gestaoadministrativa.app.EmpresaBean;
import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.app.gaException;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.core.EntityStates;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.EntityPicker;
import io.jmix.ui.model.InstanceLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Item;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Item.edit")
@UiDescriptor("item-edit.xml")
@EditedEntityContainer("itemDc")
public class ItemEdit extends StandardEditor<Item> {

    @Autowired
    private EntityStates entityStates;
    @Autowired
    private EntityPicker<GrupoEconomico> grupoEconomicoField;
    @Autowired
    private Notifications notifications;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        if (entityStates.isNew(getEditedEntity())) {
            try {

                grupoEconomicoField.setValue(grupoEconomicoBean.retornarGE());

            } catch (gaException e) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Erro ao Carregar Grupo Economico").withDescription(e.getMessage()).show();
            }

        }
    }

    @Subscribe
    public void onBeforeCommitChanges(BeforeCommitChangesEvent event) {
        if (getEditedEntity().getGrupoEconomico() == null) {
            notifications.create(Notifications.NotificationType.ERROR).withCaption("Não Autorizado").show();
            event.preventCommit();
        }
    }


}