package br.inf.mfp.gestaoadministrativa.screen.cadastros.pessoa;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.ButtonsPanel;
import io.jmix.ui.component.Filter;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Pessoa;
import org.springframework.beans.factory.annotation.Autowired;


@UiController("ga_Pessoa.browse")
@UiDescriptor("pessoa-browse.xml")
@LookupComponent("pessoasTable")
public class PessoaBrowse extends StandardLookup<Pessoa> {
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    @Autowired
    private Notifications notifications;

    private GrupoEconomico filtroGe;
    @Autowired
    private ButtonsPanel buttonsPanel;
    @Autowired
    private Filter filter;

    @Subscribe(id = "pessoasDl", target = Target.DATA_LOADER)
    public void onPessoasDlPreLoad(CollectionLoader.PreLoadEvent<Pessoa> event) {
        if (filtroGe == null) {
            try {
                filtroGe = grupoEconomicoBean.retornarGE();
            } catch (Exception ee) {
                filtroGe = null;
            }
            if (filtroGe == null) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Usuário sem Grupo Econômico").show();
                event.preventLoad();
                buttonsPanel.setEnabled(false);
                filter.setEnabled(false);
            }
        }
    }




}