package br.inf.mfp.gestaoadministrativa.screen.cadastros.pessoa;

import br.inf.mfp.gestaoadministrativa.app.EmpresaBean;
import br.inf.mfp.gestaoadministrativa.app.GeradorBean;
import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.app.gaException;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.core.EntityStates;
import io.jmix.core.security.CurrentAuthentication;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.EntityPicker;
import io.jmix.ui.component.TextField;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Pessoa;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Pessoa.edit")
@UiDescriptor("pessoa-edit.xml")
@EditedEntityContainer("pessoaDc")
public class PessoaEdit extends StandardEditor<Pessoa> {
    @Autowired
    private EntityStates entityStates;
    @Autowired
    private EntityPicker<GrupoEconomico> grupoEconomicoField;
    @Autowired
    private Notifications notifications;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    @Autowired
    private CurrentAuthentication currentAuthentication;
    @Autowired
    private TextField<Integer> codigoField;
    @Autowired
    private GeradorBean geradorBean;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        if ( entityStates.isNew(getEditedEntity()) ){
            try {

                codigoField.setValue(geradorBean.RetornoSeq("pessoa_seq"));

                grupoEconomicoField.setValue( grupoEconomicoBean.retornarGE());
            } catch (gaException e) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Erro ao Carregar Grupo Economico").withDescription(e.getMessage()).show();
            }

        }
    }

    @Subscribe
    public void onBeforeCommitChanges(BeforeCommitChangesEvent event) {
        if (getEditedEntity().getGrupoEconomico() == null) {
            notifications.create(Notifications.NotificationType.ERROR).withCaption("Não Autorizado").show();
            event.preventCommit();
        }
    }
}