package br.inf.mfp.gestaoadministrativa.screen.infogerais;

import br.inf.mfp.gestaoadministrativa.entity.Base;
import io.jmix.core.LoadContext;
import io.jmix.ui.Notifications;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.model.DataContext;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.info.BuildProperties;

import java.util.ArrayList;
import java.util.List;

@UiController("ga_InfoGerais")
@UiDescriptor("info-gerais.xml")
public class InfoGerais extends Screen {
    @Autowired
    private Notifications notifications;

    @Autowired
    private BuildProperties buildProperties;
    @Autowired
    private CollectionLoader<Base> basesDl;
    @Autowired
    private DataContext dataContext;
    @Autowired
    private CollectionContainer<Base> basesDc;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {

        basesDl.load();
    }

    @Subscribe(id = "basesDl", target = Target.DATA_LOADER)
    public void onBasesDlPreLoad(CollectionLoader.PreLoadEvent<Base> event) {




    }

    @Install(to = "basesDl", target = Target.DATA_LOADER)
    private List<Base> basesDlLoadDelegate(LoadContext<Base> loadContext) {
        List<Base> listas = new ArrayList<>();

        for (int i = 0; i < 10; i++) {

            Base lista = dataContext.create(Base.class);
            String descricao = "";
            String valor = "";

            switch (i) {
                case 0 -> {
                    descricao = "Artefato";
                    valor = buildProperties.getArtifact();
                }
                case 1 -> {
                    descricao = "Versão";
                    valor = buildProperties.getVersion();
                }
                case 2 -> {
                    descricao = "Grupo";
                    valor = buildProperties.getGroup();

                }
                case 3 -> {
                    descricao = "Nome";
                    valor = buildProperties.getName();

                }
                case 4 -> {
                    descricao = "Tempo";
                    valor = buildProperties.getTime().toString();
                }
                case 5 -> {

                }
                case 6 -> {
                }
                case 7 -> {
                }
                case 8 -> {
                }
                case 9 -> {
                }
            }


            if (descricao.length() > 0) {
                lista.setCodigo(i);
                lista.setDescricao(descricao);
                lista.setValor(valor);
                listas.add(lista);
            }

        }

        if (listas.size()>0) {
            return listas;

        }

        return null;
    }


}