package br.inf.mfp.gestaoadministrativa.screen.integrador;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.ButtonsPanel;
import io.jmix.ui.component.Filter;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Integrador;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Integrador.browse")
@UiDescriptor("integrador-browse.xml")
@LookupComponent("integradorsTable")
public class IntegradorBrowse extends StandardLookup<Integrador> {
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    private GrupoEconomico filtroGe;
    @Autowired
    private Notifications notifications;
    @Autowired
    private ButtonsPanel buttonsPanel;
    @Autowired
    private Filter filter;

    @Subscribe(id = "integradorsDl", target = Target.DATA_LOADER)
    public void onIntegradorsDlPreLoad(CollectionLoader.PreLoadEvent<Integrador> event) {

        if (filtroGe == null) {
            try {
                filtroGe = grupoEconomicoBean.retornarGE();
            } catch (Exception ee) {
                filtroGe = null;
            }
            if (filtroGe == null) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Usuário sem Grupo Econômico").show();
                event.preventLoad();
                buttonsPanel.setEnabled(false);
                filter.setEnabled(false);
            }
        }
    }
}