package br.inf.mfp.gestaoadministrativa.screen.integrador;

import br.inf.mfp.gestaoadministrativa.entity.Empresa;
import io.jmix.core.EntityStates;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Integrador;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Integrador.edit")
@UiDescriptor("integrador-edit.xml")
@EditedEntityContainer("integradorDc")
public class IntegradorEdit extends StandardEditor<Integrador> {
    @Autowired
    private EntityStates entityStates;

    @Subscribe("empresaField")
    public void onEmpresaFieldValueChange(HasValue.ValueChangeEvent<Empresa> event) {

        if (entityStates.isNew(getEditedEntity()) || !this.isReadOnly()) {
            if (event.getValue() != null) {
                if (getEditedEntity().getGrupoEconomico() != null && !getEditedEntity().getGrupoEconomico().equals(event.getValue().getGrupoEconomico())) {
                    getEditedEntity().setGrupoEconomico(event.getValue().getGrupoEconomico());
                }
            }
            else
                getEditedEntity().setGrupoEconomico(null);
        }
    }
}