package br.inf.mfp.gestaoadministrativa.screen.movimento.contrato;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.ButtonsPanel;
import io.jmix.ui.component.Filter;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Contrato;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Contrato.browse")
@UiDescriptor("contrato-browse.xml")
@LookupComponent("contratoesTable")
public class ContratoBrowse extends StandardLookup<Contrato> {

    private GrupoEconomico filtroGe;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    @Autowired
    private Notifications notifications;
    @Autowired
    private ButtonsPanel buttonsPanel;
    @Autowired
    private Filter filter;


    @Subscribe(id = "contratoesDl", target = Target.DATA_LOADER)
    public void onContratoesDlPreLoad(CollectionLoader.PreLoadEvent<Contrato> event) {
        if (filtroGe == null) {
            try {
                filtroGe = grupoEconomicoBean.retornarGE();
            } catch (Exception ee) {
                filtroGe = null;
            }
            if (filtroGe == null) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Usuário sem Grupo Econômico").show();
                event.preventLoad();
                buttonsPanel.setEnabled(false);
                filter.setEnabled(false);
            }
        }
    }

}