package br.inf.mfp.gestaoadministrativa.screen.movimento.contrato;

import br.inf.mfp.gestaoadministrativa.entity.Empresa;
import io.jmix.core.EntityStates;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Contrato;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_Contrato.edit")
@UiDescriptor("contrato-edit.xml")
@EditedEntityContainer("contratoDc")
public class ContratoEdit extends StandardEditor<Contrato> {
    @Autowired
    private EntityStates entityStates;

    @Subscribe("empresaFaturamentoField")
    public void onEmpresaFaturamentoFieldValueChange(HasValue.ValueChangeEvent<Empresa> event) {

        if (entityStates.isNew(getEditedEntity()) || !this.isReadOnly()) {
            if (event.getValue() != null) {
                if (getEditedEntity().getGrupoEconomico() != null && !getEditedEntity().getGrupoEconomico().equals(event.getValue().getGrupoEconomico())) {
                    getEditedEntity().setGrupoEconomico(event.getValue().getGrupoEconomico());
                }
            }
            else
                getEditedEntity().setGrupoEconomico(null);
        }

    }
}