package br.inf.mfp.gestaoadministrativa.screen.movimento.itempedido;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.app.gaException;
import br.inf.mfp.gestaoadministrativa.entity.Item;
import io.jmix.core.EntityStates;
import io.jmix.ui.component.EntityPicker;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.component.TextField;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.ItemPedido;
import org.springframework.beans.factory.annotation.Autowired;

import java.math.BigDecimal;

@UiController("ga_ItemPedido.edit")
@UiDescriptor("item-pedido-edit.xml")
@EditedEntityContainer("itemPedidoDc")
public class ItemPedidoEdit extends StandardEditor<ItemPedido> {

    @Autowired
    private TextField<BigDecimal> valorUnitarioField;
    @Autowired
    private TextField<Double> quantidadeField;
    @Autowired
    private TextField<BigDecimal> valorTotalField;
    @Autowired
    private EntityStates entityStates;
    @Autowired
    private EntityPicker<Item> itemField;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    @Autowired
    private CollectionLoader<Item> itemLc;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) throws gaException {
        if ( entityStates.isNew(getEditedEntity()) ) {
            quantidadeField.setValue(0D);
            valorUnitarioField.setValue(BigDecimal.ZERO);


            //getEditedEntity().setGrupoEconomico();

            itemLc.setParameter("grupo", grupoEconomicoBean.retornarGE().getId());
            itemLc.load();

        }else
        {
            itemField.setEditable(false);
        }

    }


    private void CalcularTotal(Double quantidade, BigDecimal unitario){
           BigDecimal total =BigDecimal.ZERO;
           if (this.isReadOnly()) return;

           if (quantidade != null && unitario != null) {
               if (quantidade > 0 && !unitario.equals(BigDecimal.ZERO)) {
                   total = unitario.multiply(BigDecimal.valueOf(quantidade));
               }
           }
        valorTotalField.setValue(total);
    }

    @Subscribe("quantidadeField")
    public void onQuantidadeFieldValueChange(HasValue.ValueChangeEvent<Double> event) {
        CalcularTotal(event.getValue(),valorUnitarioField.getValue());
    }

    @Subscribe("valorUnitarioField")
    public void onValorUnitarioFieldValueChange(HasValue.ValueChangeEvent<BigDecimal> event) {
        CalcularTotal(quantidadeField.getValue(), event.getValue());
    }

    @Subscribe("itemField")
    public void onItemFieldValueChange(HasValue.ValueChangeEvent<Item> event) {
        if(!this.isReadOnly()){
            if (event.getValue() != null){
                Item item = event.getValue();
                if (item.getValorCusto() != null && !item.getValorCusto().equals(BigDecimal.ZERO)){
                    valorUnitarioField.setValue(item.getValorCusto());
                }
            }
        }
    }


}