package br.inf.mfp.gestaoadministrativa.screen.movimento.movimentoestoque;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.app.gaException;
import br.inf.mfp.gestaoadministrativa.entity.Empresa;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.ButtonsPanel;
import io.jmix.ui.component.Filter;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.MovimentoEstoque;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

@UiController("ga_MovimentoEstoque.browse")
@UiDescriptor("movimento-estoque-browse.xml")
@LookupComponent("movimentoEstoquesTable")
public class MovimentoEstoqueBrowse extends StandardLookup<MovimentoEstoque> {

    private GrupoEconomico filtroGe;
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    @Autowired
    private Notifications notifications;
    @Autowired
    private ButtonsPanel buttonsPanel;
    @Autowired
    private Filter filter;
    @Autowired
    private CollectionLoader<MovimentoEstoque> movimentoEstoquesDl;

    @Subscribe(id = "movimentoEstoquesDl", target = Target.DATA_LOADER)
    public void onMovimentoEstoquesDlPreLoad(CollectionLoader.PreLoadEvent<MovimentoEstoque> event) {
        if (filtroGe == null) {
            try {
                filtroGe = grupoEconomicoBean.retornarGE();
            } catch (Exception ee) {
                filtroGe = null;
            }
            if (filtroGe == null) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Usuário sem Grupo Econômico").show();
                event.preventLoad();
                buttonsPanel.setEnabled(false);
                filter.setEnabled(false);
            }
        }
    }

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        try {
            List<Empresa> filtroEmpresa = grupoEconomicoBean.retornarEmpresas();
            movimentoEstoquesDl.setParameter("empresa", filtroEmpresa);
            movimentoEstoquesDl.load();

        } catch (
                gaException e) {
            notifications.create(Notifications.NotificationType.ERROR).withCaption("Erro ao Carregar Grupo Economico").withDescription(e.getMessage()).show();
        }
    }




}