package br.inf.mfp.gestaoadministrativa.screen.movimento.operacaoestoque;

import br.inf.mfp.gestaoadministrativa.entity.Empresa;
import br.inf.mfp.gestaoadministrativa.entity.TipoOperacao;
import io.jmix.ui.component.ComboBox;
import io.jmix.ui.component.EntityComboBox;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.OperacaoEstoque;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

//FIXME necessário mais testes com os processos da trigger,
// - principalmente com as transferencias

@UiController("ga_OperacaoEstoque.edit")
@UiDescriptor("operacao-estoque-edit.xml")
@EditedEntityContainer("operacaoEstoqueDc")
public class OperacaoEstoqueEdit extends StandardEditor<OperacaoEstoque> {
    @Autowired
    private EntityComboBox<Empresa> empresaDestinoField;
    @Autowired
    private ComboBox<TipoOperacao> tipoOperacaoField;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {

        ValidarTela();

        if (!getEditedEntity().getTipoOperacao().equals(TipoOperacao.TRANSFERENCIA_ENTRADA)){
            List<TipoOperacao> lista = new ArrayList<>();
            lista.add(TipoOperacao.BAIXA_CONSUMO);
            lista.add(TipoOperacao.PERDA);
            lista.add(TipoOperacao.TRANSFERENCIA_SAIDA);
            lista.add(TipoOperacao.CONSUMO_FUNCIONARIO);

            tipoOperacaoField.setOptionsList(lista);


        }

    }

    private void ValidarTela() {

        empresaDestinoField.setVisible (getEditedEntity().getTipoOperacao().equals(TipoOperacao.TRANSFERENCIA_SAIDA) || getEditedEntity().getTipoOperacao().equals(TipoOperacao.TRANSFERENCIA_ENTRADA));

    }

    @Subscribe("tipoOperacaoField")
    public void onTipoOperacaoFieldValueChange(HasValue.ValueChangeEvent<TipoOperacao> event) {
        ValidarTela();
    }

}