package br.inf.mfp.gestaoadministrativa.screen.movimento.pedido;

import br.inf.mfp.gestaoadministrativa.app.GeradorBean;
import br.inf.mfp.gestaoadministrativa.entity.*;
import io.jmix.core.EntityStates;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.component.TextField;
import io.jmix.ui.model.*;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@UiController("ga_Pedido.edit")
@UiDescriptor("pedido-edit.xml")
@EditedEntityContainer("pedidoDc")
public class PedidoEdit extends StandardEditor<Pedido> {
    @Autowired
    private TextField<Integer> numeroField;
    @Autowired
    private EntityStates entityStates;
    @Autowired
    private CollectionPropertyContainer<ItemPedido> itemPedidoDc;
    @Autowired
    private TextField<BigDecimal> valorTotalField;

    @Autowired
    private DataContext dataContext;
    @Autowired
    private GeradorBean geradorBean;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {

        if (getEditedEntity().getNumero() == null)
            numeroField.setValue(geradorBean.RetornoSeq("categoria_seq"));

    }

    @Subscribe(id = "itemPedidoDc", target = Target.DATA_CONTAINER)
    public void onItemPedidoDcCollectionChange(CollectionContainer.CollectionChangeEvent<ItemPedido> event) {

        if (entityStates.isNew(getEditedEntity()) || !this.isReadOnly()) {
            if (itemPedidoDc.getMutableItems().size() > 0) {
                BigDecimal valotTotal = BigDecimal.ZERO;
                for (ItemPedido itemPedido : itemPedidoDc.getMutableItems()) {
                    if (!itemPedido.getCancelado())
                        valotTotal = valotTotal.add(itemPedido.getValorTotal());
                }

                valorTotalField.setValue(valotTotal);
                AtualizarParcela();

            }
        }
    }

    private void AtualizarParcela() {
        if (entityStates.isNew(getEditedEntity()) || !this.isReadOnly()) {
            if (valorTotalField.getValue() != null && !valorTotalField.getValue().equals(BigDecimal.ZERO)) {

                int indice = -1;
                if (getEditedEntity().getParcelaPedido() != null) {


                    for (int i = 0; i < getEditedEntity().getParcelaPedido().size(); i++) {
                        if (!entityStates.isDeleted(getEditedEntity().getParcelaPedido().get(i))) {
                            indice = i;
                            break;
                        }
                    }
                }

                if (indice > -1) {
                    if (!getEditedEntity().getParcelaPedido().get(indice).getValor().equals(valorTotalField.getValue())) {
                        getEditedEntity().getParcelaPedido().get(indice).setValor(valorTotalField.getValue());
                    }
                } else {

                    ParcelaPedido parcela = dataContext.create(ParcelaPedido.class);
                    parcela.setNumero(1);
                    parcela.setValor(valorTotalField.getValue());
                    parcela.setRegistroGerar(RegistroGerar.PENDENTE);
                    parcela.setDataVencimento(new Date());
                    parcela.setPedido(getEditedEntity());
                    List<ParcelaPedido> lista = new ArrayList<>();
                    lista.add(parcela);
                    getEditedEntity().setParcelaPedido(lista);
                }

            }
        }

    }

    @Subscribe("empresaField")
    public void onEmpresaFieldValueChange(HasValue.ValueChangeEvent<Empresa> event) {


        if (entityStates.isNew(getEditedEntity()) || !this.isReadOnly()) {
            if (event.getValue() != null)
                getEditedEntity().setGrupoEconomico(event.getValue().getGrupoEconomico());
            else
                getEditedEntity().setGrupoEconomico(null);
        }
    }

}