package br.inf.mfp.gestaoadministrativa.screen.movimento.titulopagar;

import br.inf.mfp.gestaoadministrativa.app.GrupoEconomicoBean;
import br.inf.mfp.gestaoadministrativa.entity.GrupoEconomico;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.ButtonsPanel;
import io.jmix.ui.component.Filter;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.TituloPagar;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_TituloPagar.browse")
@UiDescriptor("titulo-pagar-browse.xml")
@LookupComponent("tituloPagarsTable")
public class TituloPagarBrowse extends StandardLookup<TituloPagar> {
    @Autowired
    private GrupoEconomicoBean grupoEconomicoBean;
    @Autowired
    private Notifications notifications;

    private GrupoEconomico filtroGe;
    @Autowired
    private ButtonsPanel buttonsPanel;
    @Autowired
    private Filter filter;

    @Subscribe(id = "tituloPagarsDl", target = Target.DATA_LOADER)
    public void onTituloPagarsDlPreLoad(CollectionLoader.PreLoadEvent<TituloPagar> event) {
        if (filtroGe == null) {
            try {
                filtroGe = grupoEconomicoBean.retornarGE();
            } catch (Exception ee) {
                filtroGe = null;
            }
            if (filtroGe == null) {
                notifications.create(Notifications.NotificationType.ERROR).withCaption("Usuário sem Grupo Econômico").show();
                event.preventLoad();
                buttonsPanel.setEnabled(false);
                filter.setEnabled(false);
            }
        }
    }




}