package br.inf.mfp.gestaoadministrativa.screen.traducao;

import br.inf.mfp.gestaoadministrativa.app.ClasseGenerica;
import br.inf.mfp.gestaoadministrativa.app.TraducaoBean;
import io.jmix.core.CoreProperties;
import io.jmix.ui.Notifications;
import io.jmix.ui.UiProperties;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.Table;
import io.jmix.ui.download.ByteArrayDataProvider;
import io.jmix.ui.download.DownloadFormat;
import io.jmix.ui.download.Downloader;
import io.jmix.ui.screen.*;
import br.inf.mfp.gestaoadministrativa.entity.Traducao;
import org.springframework.beans.factory.annotation.Autowired;

import java.nio.charset.StandardCharsets;
import java.util.List;

@UiController("ga_Traducao.browse")
@UiDescriptor("traducao-browse.xml")
@LookupComponent("traducaosTable")
public class TraducaoBrowse extends StandardLookup<Traducao> {
    @Autowired
    private TraducaoBean traducaoBean;
    @Autowired
    private Table<Traducao> traducaosTable;
    @Autowired
    private Notifications notifications;
    @Autowired
    private Downloader downloader;
    @Autowired
    private UiProperties uiProperties;
    @Autowired
    private CoreProperties coreProperties;

    @Subscribe("carregarBtn")
    public void onCarregarBtnClick(Button.ClickEvent event) {
        try {
            if (traducaosTable.getSingleSelected() != null) {
                traducaoBean.Carregar(traducaosTable.getSingleSelected().getId());
                notifications.create(Notifications.NotificationType.HUMANIZED).withCaption("Processo executado").show();

            }

        }
        catch (Exception ee){
            notifications.create(Notifications.NotificationType.ERROR).withCaption("Erro").withDescription(ee.getMessage()).show();
        }
    }

    @Install(to = "traducaosTable.carregarArquivo", subject = "enabledRule")
    private boolean traducaosTableCarregarArquivoEnabledRule() {
        if (traducaosTable.getSingleSelected() != null) {
            return traducaosTable.getSingleSelected().getArquivoOriginal() != null;
        }
        return false;
    }

    @Subscribe("geralBtn")
    public void onGeralBtnClick(Button.ClickEvent event) {
        try {
            if (traducaosTable.getSingleSelected() != null) {
                traducaoBean.TraduzirArq(traducaosTable.getSingleSelected().getId());
                notifications.create(Notifications.NotificationType.HUMANIZED).withCaption("Processo executado").show();

            }

        }
        catch (Exception ee){
            notifications.create(Notifications.NotificationType.ERROR).withCaption("Erro").withDescription(ee.getMessage()).show();


        }
    }

    @Subscribe("salvarBtn")
    public void onSalvarBtnClick(Button.ClickEvent event) {
        if (traducaosTable.getSingleSelected() != null) {

            ClasseGenerica retorno = traducaoBean.SalvarArquivo(traducaosTable.getSingleSelected().getId());

            if (retorno.getLinhas() != null){

                byte[] bytes = retorno.getLinhas().toString().getBytes(StandardCharsets.UTF_8);

                downloader.download(new ByteArrayDataProvider(bytes,
                                uiProperties.getSaveExportedByteArrayDataThresholdBytes(), coreProperties.getTempDir()),
                        retorno.getNomeArquivo(), DownloadFormat.TEXT);

            }

        }

    }
}