package br.inf.mfp.gestaoadministrativa.screen.user;

import br.inf.mfp.gestaoadministrativa.entity.User;
import br.inf.mfp.gestaoadministrativa.screen.multiempresa.MultiEmpresa;
import io.jmix.ui.Screens;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.GroupTable;
import io.jmix.ui.navigation.Route;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ga_User.browse")
@UiDescriptor("user-browse.xml")
@LookupComponent("usersTable")
@Route("users")
public class UserBrowse extends StandardLookup<User> {
    @Autowired
    private Screens screens;
    @Autowired
    private GroupTable<User> usersTable;

    @Subscribe("empresasUser")
    public void onEmpresasUserClick(Button.ClickEvent event) {
        if (usersTable.getSingleSelected() == null)
            return;

        MultiEmpresa mem = screens.create(MultiEmpresa.class);
        mem.addAfterCloseListener(e -> {

        });
        mem.setLoginUsuario(usersTable.getSingleSelected().getUsername());
        mem.show();
    }

    @Install(to = "usersTable.empresasUser", subject = "enabledRule")
    private boolean usersTableEmpresasUserEnabledRule() {

        return (usersTable.getSingleSelected() != null);
    }
}