package br.inf.mfp.gestaoadministrativa.security;

import br.inf.mfp.gestaoadministrativa.entity.*;
import io.jmix.security.model.EntityAttributePolicyAction;
import io.jmix.security.model.EntityPolicyAction;
import io.jmix.security.role.annotation.*;
import io.jmix.securityui.role.annotation.MenuPolicy;
import io.jmix.securityui.role.annotation.ScreenPolicy;

@ResourceRole(name = "Pedido", code = "pedido")
public interface PedidoRole {
    @MenuPolicy(menuIds = "ga_Pedido.browse")
    @ScreenPolicy(screenIds = {"ga_Pedido.browse", "ga_Pedido.edit", "ga_ItemPedido.edit", "ga_Empresa.browse", "ga_Pessoa.browse"})
    @SpecificPolicy(resources = {"cancelarPedido", "liberarPedido"})
    void screens();

    @EntityAttributePolicy(entityClass = ItemPedido.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = ItemPedido.class, actions = EntityPolicyAction.ALL)
    void itemPedido();

    @EntityAttributePolicy(entityClass = RetornoPedido.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = RetornoPedido.class, actions = EntityPolicyAction.ALL)
    void retornoPedido();

    @EntityAttributePolicy(entityClass = Pedido.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Pedido.class, actions = EntityPolicyAction.ALL)

    void pedido();

    @EntityAttributePolicy(entityClass = Empresa.class, attributes = "*", action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Empresa.class, actions = EntityPolicyAction.READ)
    void empresa_consulta();

    @EntityAttributePolicy(entityClass = GrupoEconomico.class, attributes = "*", action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = GrupoEconomico.class, actions = EntityPolicyAction.READ)
    void grupoEconomico_consulta();

    @EntityAttributePolicy(entityClass = Pessoa.class, attributes = "*", action = EntityAttributePolicyAction.VIEW)
    @EntityPolicy(entityClass = Pessoa.class, actions = EntityPolicyAction.READ)
    void pessoa_consulta();






}