-- FUNCTION: public.ga_fun_gera_movimento_estoque(uuid, uuid, date, integer, uuid, integer, double precision, numeric)

-- DROP FUNCTION IF EXISTS public.ga_fun_gera_movimento_estoque(uuid, uuid, date, integer, uuid, integer, double precision, numeric);

CREATE OR REPLACE FUNCTION public.ga_fun_gera_movimento_estoque(
	pempresaid uuid,
	pitemid uuid,
	pdatamovimento date,
	pcodtipomovimento integer,
	pidorigem uuid,
	porigem integer,
	pquantidade double precision,
	pvalorcusto numeric)
    RETURNS uuid
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE PARALLEL UNSAFE
AS $BODY$

 DECLARE
 	
	vRetornoId UUID;
	vIdTipoMovimento UUID;
	vValorTotal NUMERIC(15,5);
 BEGIN
 	
	vRetornoId = uuid_generate_v4();
	
	SELECT
		tm.ID
		INTO vIdTipoMovimento
	FROM tipo_movimento tm 
	WHERE tm.codigo = pcodtipomovimento;

	IF (vIdTipoMovimento is null) THEN
		RAISE EXCEPTION 'Não foi localizado o tipo de movimento de estoque (%), acionar o suporte', pcodtipomovimento;
	END IF;

	vValorTotal = pValorCusto * CAST(pQuantidade AS numeric(15,5)) ;

	INSERT INTO public.movimento_estoque (
		id ,
		empresa_id ,
		item_id ,
		data_movimento ,
		tipo_movimento_id ,
		id_origem ,
		origem ,
		quantidade ,
		valor_custo ,
		valor_movimento 
	) VALUES (
		vRetornoId,
		pEmpresaId,
		pItemId,
		pDataMovimento,
		vIdTipoMovimento,
		pIdOrigem,
		pOrigem,
		pQuantidade,
		pValorCusto,
		vValorTotal
	
	);
	
	
 	RETURN vRetornoId;
 	
 END;
 
$BODY$;

ALTER FUNCTION public.ga_fun_gera_movimento_estoque(uuid, uuid, date, integer, uuid, integer, double precision, numeric)
    OWNER TO postgres;
