-- FUNCTION: public.ga_tbu_operacao_estoque()

-- DROP FUNCTION IF EXISTS public.ga_tbu_operacao_estoque();

CREATE OR REPLACE FUNCTION public.ga_tbu_operacao_estoque()
    RETURNS trigger
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE NOT LEAKPROOF
AS $BODY$
DECLARE 
	REC_PEDIDO RECORD;
	REC_RETORNO RECORD;
	vMovimentoId UUID;
	vRetornoId UUID;
	vCustoItem NUMERIC(15,5);
 	vValortotal NUMERIC(15,5);
BEGIN

	IF (NEW.situacao_operacao = 20) THEN

		raise notice 'passou 20';
	
		FOR REC_RETORNO IN
			SELECT 
				oi.*,
				i.codigo,
				i.descricao,
				i.valor_custo
			FROM operacao_item oi
			INNER JOIN item AS i ON(i.id = oi.item_id)
			WHERE oi.operacao_estoque_id = NEW.id
		LOOP
			
			
			raise notice 'Item - % - % , quantidade %', REC_RETORNO.codigo, REC_RETORNO.descricao, REC_RETORNO.quantidade;
			
			raise notice 'operacao -  %', new.tipo_operacao;
			
			vCustoItem =  REC_RETORNO.valor_custo ;
							
			raise notice 'vCustoItem % ', vCustoItem;
			
			vMovimentoId = ga_fun_gera_movimento_estoque( 
				NEW.empresa_origem_id,
				REC_RETORNO.item_id,
				NEW.data_movimento,
				CASE WHEN NEW.tipo_operacao = 10 THEN 9
				     WHEN NEW.tipo_operacao = 20 THEN 10
					 WHEN NEW.tipo_operacao = 30 THEN 6
				     WHEN NEW.tipo_operacao = 40 THEN 5
					 WHEN NEW.tipo_operacao = 50 THEN 11
				     ELSE 99 END
				     ,
				REC_RETORNO.id,
				CASE WHEN NEW.tipo_operacao = 10 THEN 40
				     WHEN NEW.tipo_operacao = 20 THEN 50
					 WHEN NEW.tipo_operacao = 30 THEN 60
				     WHEN NEW.tipo_operacao = 40 THEN 70
				     WHEN NEW.tipo_operacao = 50 THEN 80
				     ELSE 99 END
				     ,
				REC_RETORNO.quantidade,
				vCustoItem
				);
			
			RAISE NOTICE 'vMovimentoId %', vMovimentoId;
		
			UPDATE operacao_item SET
				movimento_estoque_id = vMovimentoId
			WHERE id = REC_RETORNO.ID;
			
		END LOOP;
	
		
		/* se o tipo for transferencia de saida, precisa criar a de entrada, mas pendente*/
		IF (NEW.tipo_operacao = 30) THEN
			vRetornoId = uuid_generate_v4();
			
			INSERT INTO public.operacao_estoque(id, version, created_by, created_date, last_modified_by, last_modified_date, deleted_by, deleted_date, tipo_operacao, situacao_operacao, empresa_origem_id, empresa_destino_id, data_movimento, observacao, operacao_destino_id)
			SELECT vRetornoId, 1, created_by, now(), last_modified_by, now(), NULL, NULL, 
				   40 , --tipo_operacao, 
				   10 , --situacao_operacao, 
				   NEW.empresa_destino_id , --empresa_origem_id, 
				   NULL, --empresa_destino_id, 
				   new.data_movimento, --data_movimento, 
				   'Operação Automática', --observacao, 
				   NULL --operacao_destino_id
			FROM operacao_estoque 
			WHERE id = NEW.id;
			
			INSERT INTO public.operacao_item(id, operacao_estoque_id, item_id, quantidade, movimento_estoque_id)
			SELECT uuid_generate_v4(), 
					vRetornoId, 
					item_id, 
					quantidade, 
					NULL --movimento_estoque_id
			FROM public.operacao_item
			WHERE operacao_estoque_id = NEW.id;
			
			NEW.operacao_destino_id = vRetornoId;
		
		END IF;
		
	
	ELSEIF (NEW.situacao_operacao IN(10) AND OLD.situacao_operacao = 20) THEN
	
		/* se for operação de transferencia de entrada, não pode ser removida, apenas cancelada*/
		IF (OLD.tipo_operacao = 40) THEN
			RAISE EXCEPTION 'Operação de Transferência de Entrada, precisa ser analisada.';
		END IF;
		
		IF (OLD.tipo_operacao = 30) THEN
			RAISE EXCEPTION 'Operação de Transferência de Saída, precisa ser analisada.';
		END IF;
		

		FOR REC_RETORNO IN
			SELECT 
				oi.*,
				i.codigo,
				i.descricao,
				i.valor_custo
			FROM operacao_item oi
			INNER JOIN item AS i ON(i.id = oi.item_id)
			WHERE oi.operacao_estoque_id = NEW.id			
			
			
		LOOP

			raise notice 'passou de 20 para 10';
			
			UPDATE operacao_item SET
				movimento_estoque_id = NULL
			WHERE id = REC_RETORNO.ID;
			
			DELETE FROM movimento_estoque 
			WHERE id = REC_RETORNO.movimento_estoque_id;
		
		END LOOP;
	
	else 
		
		raise notice 'outro';
	
  END IF;

  RETURN NEW;

END;
$BODY$;

ALTER FUNCTION public.ga_tbu_operacao_estoque()
    OWNER TO postgres;


DROP TRIGGER IF EXISTS tg_tbu_operacao_estoque ON public.operacao_estoque;

CREATE TRIGGER tg_tbu_operacao_estoque
    BEFORE UPDATE OF situacao_operacao
    ON public.operacao_estoque
    FOR EACH ROW
    EXECUTE FUNCTION public.ga_tbu_operacao_estoque();